#include "WorkerStorageCheck.h"

#include "ProcessConfig.h"
#include "Logger.h"
#include "FhsShm.h"
#include "StorageCheck.h"

#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <time.h>


// Storage status Check 주기 (sec)
// - service check 모듈에서 30 sec timeout 처리
// - 1회 Check 당 sleep 등으로 인해 2 sec 미만 시간 소요
// - 따라서 8 sec 마다 check 하도록 설정함.
#define STORAGE_CHECK_INTERVAL    8 


// 공유메모리에 Data Set, Get 을 담당할 객체에 대한 포인터.
// Main 프로세스에서 생성 처리하며... 전역변수로 설정되어 있다.
extern CFhsShm * g_pFhsShm;


// Worker::StorageCheck 프로세스의 Main 역활을 수행하기 위한 함수.
int WorkerStorageCheckMain()
{
	setproctitle( "StorageCheck [initialize]" );

	// Set Signal Handler
	SetWorkerStorageCheckSignalHandler();
	

	// Main Process 에서 생성한 공유메모리 접근 객체 유효성 확인
	// NULL 인 경우... 초기화 실패로 처리한다.
	if( g_pFhsShm == NULL )
	{
		// 객체 생성 실패시
		LOG( LERR, "[StorageCheck:%d] Shared memory object not valid. process exit", getpid() );

		ReadyToExitWorkerStorageCheck();
		return EXIT_FAILURE;
	}

	// Storage status check 작업을 수행할 객체 생성 및 초기화
	CStorageCheck storageCheck( g_pFhsShm );
	if( storageCheck.Init( CProcessConfig::GetInstance()->GetStorageRoot() ) == false )
	{
		// 객체 생성 실패시
		LOG( LERR, "[StorageCheck:%d] storage check module init fail. process exit", getpid() );

		ReadyToExitWorkerStorageCheck();
		return EXIT_FAILURE;
	}


	// 전체 프로세스의 생성이 완료될때까지 대기 후 작업 시작
	sleep( 1 );
	setproctitle( "StorageCheck" );

	struct timespec sleepLoop;
	sleepLoop.tv_sec = STORAGE_CHECK_INTERVAL;
	sleepLoop.tv_nsec = 0;

	// 실제 Storage Check 수행 전 공유메모리 값에 현재 시간 정보 기록 처리
	// - timeout 처리시 사용할 수 있도록 초기화 시키기 위함
	g_pFhsShm->UpdateTimeStorageCheck( true );


	// Check 결과 정보 저장을 위한 변수.
	bool bCheckResult;

	// 주기적으로 Storage 상태를 점검 처리한다.
	while( 1 )
	{
		// Storage 상태 Check 수행.
		bCheckResult = storageCheck.Check( CProcessConfig::GetInstance()->GetStorageRoot() );

		// Check 결과에 따른 공유메모리 업데이트 작업 수행
		// - 위의 check() 함수가 hang 걸릴 경우 아래 시간 업데이트 못하므로.. expire 기능 필요.
		g_pFhsShm->UpdateTimeStorageCheck( bCheckResult );

		// 지정된 시간동안 sleep
		nanosleep( &sleepLoop, NULL );
	}
	
	// 종료시 정리 작업 수행
	ReadyToExitWorkerStorageCheck();
	return EXIT_SUCCESS;
}

// 프로세스 종료 전 처리할 종료 관련 각 작업을 일괄로 처리하기 위한 함수.
void ReadyToExitWorkerStorageCheck()
{
	// Logger 객체 종료 처리.
	CLogger::Exit();

	return;
}

// Worker StorageCheck 프로세스에 대한 대한 종료 처리 수신시.
static void SignalWorkerStorageCheckTerminate( int nSignalNumber )
{
	// Signal Number 에 따른 로깅처리.
	if( nSignalNumber == SIGTERM )
	{
		_LOG( LINF, "[StorageCheck:%d] Process exit by SIGTERM signal. Good Bye..", getpid() );
	}
	else
	{
		_LOG( LWAR, "[StorageCheck:%d] Process exit by abnormal signal[%d], Good Bye..", getpid(), nSignalNumber );
	}

	ReadyToExitWorkerStorageCheck();

	// 종료전 잠시 대기
	struct timespec sleep;
	sleep.tv_sec = 0;
	sleep.tv_nsec = 500000000;  // 0.5 sec
	nanosleep( &sleep, NULL );

	exit( EXIT_SUCCESS );
}

// Worker::StorageCheck Process 의 signal 처리기...
void SetWorkerStorageCheckSignalHandler()
{
	sigset_t set;
	struct sigaction act;

	memset( &act, 0x00, sizeof( act ) );
	sigfillset( &set );
	sigprocmask( SIG_SETMASK, &set, NULL );
	sigfillset( &act.sa_mask );

	// 무시 처리 signal
	act.sa_handler = SIG_IGN;
	sigaction( SIGPIPE, &act, NULL );	/* desciptor 오류 발생시 Process가 죽는 것은 방지하기 위하여 설정 */
	sigaction( SIGHUP, &act, NULL );	/* process를 기동시킨 관리자의 로그아웃시, 또는 config reload 등의 처리 signal*/
	sigaction( SIGINT, &act, NULL );	/* ^C 키를 누른 경우 받는 신호 => demon 으로 기동되기 땜시 이 신호 못받음 */
	sigaction( SIGQUIT, &act, NULL );	/* 키보드에 의한  Abort 신호 처리 => ? */

	// Worker 프로세스는 자식 프로세스가 존재하지 않으므로 그냥 무시처리함.
	act.sa_handler = SIG_IGN;
	sigaction( SIGCHLD, &act, NULL );

	/* 각종 에러나 사용자의 종료 신호 처리 */
	act.sa_handler = SignalWorkerStorageCheckTerminate;
	sigaction( SIGTERM, &act, NULL );	/* kill -TERM 에 의한 프로세스 종료시 */

	// 나머지 신호는 default 처리.

	sigemptyset( &set );                  /* 신호 처리기 처리 설정 위한 블록 해제 */
	sigprocmask( SIG_SETMASK, &set, NULL );
}
